<?php

/**
 * Class Propoza_Propoza_Block_Adminhtml_System_Config_Buttons_Testconnection
 */
class Propoza_Propoza_Block_Adminhtml_System_Config_Buttons_Testconnection
    extends Mage_Adminhtml_Block_System_Config_Form_Field
{
    /**
     * Propoza_Propoza_Block_Adminhtml_System_Config_Buttons_Testconnection constructor.
     */
    public function _construct()
    {
        parent::_construct();
        $this->validateApiKey();
        $this->setTemplate('propoza/system/config/buttons/button_test_connection.phtml');
    }

    /**
     *
     */
    protected function validateApiKey()
    {
        $apiKey = Mage::getStoreConfig('propoza/general/api_key');
        if (!empty($apiKey) && !Mage::helper('propoza')->isValidApiKey($apiKey)) {
            $link = sprintf(
                '<a href="%s" target="_blank">Dashboard</a>', Mage::helper('propoza')->getDashboardPropozaUrl()
            );
            $apiKeyOutdatedMessage = 'Your Propoza API key is outdated. 
            For security reasons please generate a new API key and save it to your dashboard and module. %s';

            $this->getMessagesBlock()->addWarning(
                Mage::helper('propoza')->__(
                    $apiKeyOutdatedMessage,
                    $link
                )
            );
        }
    }

    /**
     * @param Varien_Data_Form_Element_Abstract $element
     *
     * @return string
     */
    public function render(Varien_Data_Form_Element_Abstract $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();

        return parent::render($element);
    }

    /**
     * @return Mage_Core_Block_Abstract
     */
    protected function _prepareLayout()
    {
        $this->getLayout()->getBlock('head')->addJs('lib/jquery/jquery-1.10.2.min.js');
        $this->getLayout()->getBlock('head')->addJs('lib/jquery/noconflict.js');

        return parent::_prepareLayout();
    }

    /**
     * @param Varien_Data_Form_Element_Abstract $element
     *
     * @return string
     */
    // @codingStandardsIgnoreLine
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)// @codingStandardsIgnoreEnd
    {
        return $this->_toHtml();
    }
}