<?php
require_once(Mage::getModuleDir('controllers', 'Mage_Core') . DS . 'AjaxController.php');
/**
 * Class Propoza_Propoza_AjaxController
 */
class Propoza_Propoza_AjaxController extends Mage_Core_AjaxController
{
    /**
     *
     */
    public function testConnectionAction()
    {
        $subDomain = $this->getRequest()->getPost('sub_domain');
        $client = new Varien_Http_Client(Mage::helper('propoza')->getConnectionTestUrl($subDomain));
        // @codingStandardsIgnoreLine
        $apiKey = explode(':', base64_decode(trim($this->getRequest()->getPost('api_key'))), 2);
        $client->setAuth($apiKey[0], $apiKey[1], Varien_Http_Client::AUTH_BASIC);
        $client->setMethod(Varien_Http_Client::GET);
        $client->setHeaders('Content-Type', 'application/json');
        $client->request()->getBody();
        $client->setConfig(array('strictredirects' => true));
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody($client->request()->getBody());
    }

    /**
     *
     */
    public function requestQuoteFormHtmlAction()
    {
        $clonedQuote = Mage::getSingleton('checkout/session')->getQuote()->cloneQuote();
        $clonedQuote->setIsActive(false)->save();

        $config = null;
        if (!Mage::app()->getStore()->isCurrentlySecure()) {
            $config = array(
                'verify_peer' => false,
                'allow_self_signed' => true,
            );
        }
        $client = new Varien_Http_Client(Mage::helper('propoza')->getQuoteRequestFormUrl(),  $config);

        // @codingStandardsIgnoreLine
        $apiKey = explode(':', base64_decode(Mage::getStoreConfig('propoza/general/api_key')), 2);
        $client->setAuth($apiKey[0], $apiKey[1], Varien_Http_Client::AUTH_BASIC);
        $client->setMethod(Varien_Http_Client::POST);
        $client->setHeaders('Content-Type', 'application/json');
        $data = Mage::helper('propoza/request')->prepareQuoteRequest($clonedQuote);
        $client->setRawData(json_encode($data), 'application/json');
        $client->setConfig(array('strictredirects' => true));
        $this->getResponse()->setHeader('Content-type', 'text/html');
        $this->getResponse()->setBody($client->request()->getBody());
    }

    /**
     *
     */
    public function requestQuoteFormSubmitAction()
    {
        $config = null;
        if (!Mage::app()->getStore()->isCurrentlySecure()) {
            $config = array(
                'verify_peer' => false,
                'allow_self_signed' => true,
            );
        }
        $client = new Varien_Http_Client($this->getRequest()->getPost('form-action'), $config);

        // @codingStandardsIgnoreLine
        $apiKey = explode(':', base64_decode(Mage::getStoreConfig('propoza/general/api_key')), 2);
        $client->setAuth($apiKey[0], $apiKey[1], Varien_Http_Client::AUTH_BASIC);
        $client->setMethod(Varien_Http_Client::POST);
        $client->setHeaders('Content-Type', 'application/json');
        $client->setRawData(json_encode($this->getRequest()->getPost('data')), 'application/json');
        $client->setConfig(array('strictredirects' => true));
        $this->getResponse()->setHeader('Content-type', 'text/html');
        $this->getResponse()->setBody($client->request()->getBody());
    }
}
