(function ($) {
    $(function () {
        var loader_container = $('#loader-container');
        var api_key_element = $('#propoza_general_api_key');
        var sub_domain_element = $('#propoza_general_web_address');
        var propoza_dashboard_link = $('#propoza_launch_propoza');
        var test_connection_button = $('#propoza_test_connection');
        var propoza_setup_button = $('#propoza_setup_sign_up');

        propoza_dashboard_link.hideOnEmptyValue(sub_domain_element.attr('id'));
        test_connection_button.hideOnEmptyValue([api_key_element.attr('id'), sub_domain_element.attr('id')]);

        sub_domain_element.on('input', function () {
            propoza_dashboard_link.hideOnEmptyValue(sub_domain_element.attr('id'));
            test_connection_button.hideOnEmptyValue([api_key_element.attr('id'), sub_domain_element.attr('id')]);

            /**
             * get sub-domain from input value if entered a full url e.g.
             * demo.propoza.com
             * demo.local.propoza.com
             * http://demo.propoza.com
             * http://demo.local.propoza.com
             * https://demo.propoza.com
             * https://demo.local.propoza.com
             *
             * @type {RegExp}
             */
            var regex = /(http[s]?:\/\/)?(.*)\.propoza\.com/g;
            var result = regex.exec(sub_domain_element.val());
            if (result !== null) {
                sub_domain_element.val(result[2]);
            }
        });

        api_key_element.on('input', function () {
            test_connection_button.hideOnEmptyValue([api_key_element.attr('id'), sub_domain_element.attr('id')]);
        });

        propoza_dashboard_link.click(function (e) {
            window.open(propoza_dashboard_link.attr('href').replace('%s', sub_domain_element.val()));
            e.preventDefault();
        });

        propoza_setup_button.click(function (e) {
            window.open(propoza_setup_button.attr('href'));
            e.preventDefault();
        });

        test_connection_button.click(function () {
            loader_container.show();
            $.post(testConnectionUrl, {
                'api_key': api_key_element.val(),
                'sub_domain': sub_domain_element.val()
            }, function (data) {
                loader_container.hide();
                show_message(data.response);
            }, 'json').fail(function () {
                loader_container.hide();
                show_message(false);
            });
        });

        function show_message(success) {
            if (success === true) {
                alert(successMessage);
            } else {
                alert(failedMessage);
            }
        }
    });

    $.fn.hideOnEmptyValue = function (elementIds) {
        if ($.isArray(elementIds)) {
            hasValue = true;
            $.each(elementIds, function (index, value) {
                if ($('#' + value).val() == '') {
                    return hasValue = false;
                }
            });
        }
        else {
            hasValue = $('#' + elementIds).val() !== '';
        }
        if (hasValue) {
            $(this).show();
        } else {
            $(this).hide();
        }
    }
})(jQuery);